// This Source Code Form is subject to the terms of the Mozilla Public
// License, v. 2.0. If a copy of the MPL was not distributed with this
// file, You can obtain one at https://mozilla.org/MPL/2.0/.



ng-container(*ngIf="!(loading$ | async) else loading")
  div(*ngIf="(workflowRun$ | async) as workflowRun", nz-row)
    aside(nz-col, nzSpan="7")
      ryax-is-logged
        a(routerLink="/workflow/{{workflowRun.workflowId}}/runs", nz-button, [nzGhost]="true", nzType="default")
          i(nz-icon, nzType="arrow-left", nzTheme="outline")
          | Workflow description
      div
        h1 Run {{ workflowRun.id }}
      ryax-status-tag([status]="workflowRun.status")
      span {{ workflowRun.startedAt | dateTimeToFormat : 'dd/MM/yy tt' }}

      ng-container(*ngIf="workflowRun.status == WorkflowRunStatus.Running else isStopped")
        button.ryax-action-button(nz-button, nzDanger, nzGhost, nzType="primary", (click)="stopRun(workflowRun.id)")
          span(nz-icon, nzType="close", nzTheme="outline", nz-tooltip, nzTooltipTitle="Stop the Run")
          | Stop
      ng-template(#isStopped)
         button.ryax-action-button(nz-button, nzDanger, nzGhost, nzType="primary", (click)="deleteRun(workflowRun.id)", [routerLink]="'/workflow/' + workflowRun.workflowId + '/runs'")
          span(nz-icon, nzType="delete", nzTheme="outline", nz-tooltip, nzTooltipTitle="Delete the Run")
          | Delete
      button#ryax-toggle(nz-button, nzType="primary", nzGhost="true", (click)="toggleAllDetails()") {{ areAllDetailsOpen() ? 'Hide' : 'View' }} all outputs
      button#ryax-result(nz-button, nzType="primary", nzGhost="true", (click)="displayResults()") See results

      ul
        li(*ngFor="let actionRun of workflowRun.actionRuns")
          ryax-status-icon([status]="actionRun.status")
          | {{ actionRun.name }}

    section(nz-col, nzSpan="16", nzOffset="1" )
      ryax-timeline([startColor]="workflowRun.status | statusBarColor : 'start'", [endColor]="workflowRun.status | statusBarColor : 'end'")
        ryax-timeline-item(*ngFor="let actionRun of workflowRun.actionRuns; let index = index; trackBy: trackByFn",
          [color]="actionRun.status | statusBarColor : 'item'", [status]="actionRun.status")
          ryax-action-run-card(
            [actionRunInput]="actionRun", [(showDetails)]="showAllDetails[index]",
            [index]="index"
          )

nz-modal([(nzVisible)]="showResults", nzTitle="Results", (nzOnCancel)="handleCancel()", [nzFooter]="modalFooter")
  ng-container(*nzModalContent)
    p {{ resultUrl }}
    nz-spin([nzSpinning]="loadingResults$ | async")
      ryax-console-display([textContent]="(results$ | async) || 'This run sent no result'")

ng-template(#modalFooter)
  button(nz-button, nzType="default", (click)="handleCancel()") Close
ng-template(#loading)
  nz-spin.ryax-main([nzSpinning]="(loading$ | async)", nzTip="Loading run details")
